<!doctype html>
<html>

<head>
  <meta name="generator" content="JSDoc 3.6.3">
  <meta charset="utf-8">
  <title>Source: components/iframe/Iframe.js</title>
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Karla:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Noto+Serif:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Inconsolata:500" type="text/css">
  <link href="css/baseline.css" rel="stylesheet">
</head>

<body onload="prettyPrint()">
  <nav id="jsdoc-navbar" role="navigation" class="jsdoc-navbar">
    <div id="jsdoc-navbar-container">
      <div id="jsdoc-navbar-content">
        <a href="index.html" class="jsdoc-navbar-package-name">Home</a>
      </div>
    </div>
  </nav>
  <div id="jsdoc-body-container">
    <div id="jsdoc-content">
      <div id="jsdoc-content-container">
        <div id="jsdoc-banner" role="banner">
        </div>
        <div id="jsdoc-main" role="main">
          <header class="page-header">
            <h1>Source: components/iframe/Iframe.js</h1>
          </header>
          <article>
            <pre class="prettyprint linenums"><code>import style from &#x27;./style.scss&#x27;
import { h, Component } from &#x27;preact&#x27;
import { Messenger } from &#x27;models/messenger.js&#x27;

let classNames &#x3D; (require(&#x27;classnames/bind&#x27;)).bind(style)

/**
 * iframe z obslugą komunikcji za pomocą PostMessages
 *
 * @class Iframe
 * @extends {Component}
 * @example
 * &amp;lt;Iframe
 *   width&#x3D;&quot;300px&quot;
 *   height&#x3D;&quot;250px&quot;
 *   url&#x3D;&quot;http://example.com&quot;
 *   package&#x3D;{
 *     &#x27;event1&#x27;: &#x27;http://example.com/event1.gif&#x27;,
 *     &#x27;event2&#x27;: &#x27;http://example.com/event2.gif&#x27;,
 *     &#x27;event3&#x27;: &#x27;http://example.com/event3.gif&#x27;
 *   }
 *   style&#x3D;{
 *    &#x27;border&#x27;: &#x27;3px dotted red&#x27;
 *   }
 *   onShow&#x3D;function(){}
 * /&gt;
 *
 * @prop {object} props - zestaw właściwości komponentu
 * @prop {string} props.src - adres iframe
 * @prop {string} [props.width] - szerokość komponentu wraz z jednostką
 * @prop {string} [props.height] - wysokość komponentu wraz z jednostką
 * @prop {string} [props.objectFit&#x3D;contain] - @see https://developer.mozilla.org/en-US/docs/Web/CSS/object-fit
 * @prop {string} [props.validate&#x3D;never] - @see https://developer.mozilla.org/en-US/docs/Mozilla/Tech/XUL/image#a-validate
 * @prop {object} [props.style] - obiekt ze stylami inline
 * @prop {function} [props.onLoad] - callback wywoływany po załadowaniu się źródła wyrenderowanego iframe
 * @prop {function} [props.onHello] - callback wywoływany po udanym nawiązaniu komunikacji z iframe
 * @prop {function} [props.onShow] - callback wywoływany przez iframe (lub automatycznie, jesli nie uda się nawiązać komunikacji)
 * @prop {function} [props.onHide] - callback wywoływany przez iframe
 */
export class Iframe extends Component {
  constructor (props, state) {
    super(props, state)

    this.state.status &#x3D; &#x27;initialized&#x27;

    this.onHello &#x3D; this.onHello.bind(this)
    this.onShow &#x3D; this.onShow.bind(this)
    this.onHide &#x3D; this.onHide.bind(this)
  }

  /**
   * funkcja wywoływana po nawiązaniu udanej komunikacji z iframką za pomocą PostMessages
   */
  onHello () {
    this.setState({ status: &#x27;contact&#x27; })
    if (typeof this.props.package &#x3D;&#x3D;&#x3D; &#x27;object&#x27;) this.messenger.send(&#x27;package&#x27;, this.props.package)
    if (typeof this.props.onHello &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onHello()
  }

  /**
   * jeżeli przez 100ms nie uda się nawiązać komunikacji z iframe, onShow jest wywoływane automatycznie
   * w innym przypadku czeka na odpowiednią wiadomość z iframe
   */
  onShow () {
    this.setState({ status: &#x27;shown&#x27; })
    if (typeof this.props.onShow &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onShow()
  }

  /**
   * funkcja wywoływana przez iframe
   */
  onHide () {
    this.setState({ status: &#x27;hidden&#x27; })
    if (typeof this.props.onHide &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onHide()
  }

  componentDidMount () {
    this.messenger &#x3D; new Messenger({
      source: {
        node: window,
        origin: window.location.origin
      },
      target: {
        node: this.base.contentWindow,
        origin: this.props.src
      }
    })

    let autoShow &#x3D; setTimeout(() &#x3D;&gt; {
      if (typeof this.props.onShow &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onShow()
    }, 100)

    this.messenger.on(&#x27;hello&#x27;, () &#x3D;&gt; {
      clearTimeout(autoShow)
      this.onHello()
    })
    this.messenger.on(&#x27;show&#x27;, () &#x3D;&gt; this.onShow())
    this.messenger.on(&#x27;hide&#x27;, () &#x3D;&gt; this.onHide())
  }

  /**
   * obsługa eventu onLoad dla iframe
   */
  handleOnLoad () {
    this.messenger.send(&#x27;hello&#x27;)
    this.setState({ status: &#x27;loaded&#x27; })
    if (typeof this.props.onLoad &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onLoad()
  }

  render () {
    return (
      &amp;lt;iframe
        width&#x3D;{ this.props.width }
        height&#x3D;{ this.props.height }
        src&#x3D;{ this.props.src }
        scrolling&#x3D;&quot;no&quot;
        allow&#x3D;&quot;autoplay,accelerometer,fullscreen,geolocation,gyroscope,speaker&quot;
        allowFullScreen
        referrerpolicy&#x3D;&quot;origin-when-cross-origin&quot;
        className&#x3D;{ classNames(&#x27;iframe&#x27;) }
        onLoad&#x3D;{ this.handleOnLoad }
      /&gt;
    )
  }
}
</code></pre>
          </article>
        </div>
      </div>
      <nav id="jsdoc-toc-nav" role="navigation"></nav>
    </div>
  </div>
  <footer id="jsdoc-footer" class="jsdoc-footer">
    <div id="jsdoc-footer-container">
      <p>
        Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc</a> 3.6.3 on August 23, 2019.
      </p>
    </div>
  </footer>
  <script src="scripts/jquery.min.js"></script>
  <script src="scripts/jquery.cookie.js"></script>
  <script src="scripts/tree.jquery.js"></script>
  <script src="scripts/prettify.js"></script>
  <script src="scripts/jsdoc-toc.js"></script>
  <script src="scripts/linenumber.js"></script>
  <script src="scripts/scrollanchor.js"></script>
</body>

</html>